/* 
   $Id: callbacks.c,v 1.8 2002/01/17 09:10:09 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgswtheme.

   sgswtheme is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgswtheme is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <X11/X.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "sgswtheme.h"


static int changeGtkrc(void)
{
    char buf[1024];
    FILE *fp;
    char *homeDir;

    homeDir = g_get_home_dir();
    g_snprintf(buf,1024,"%s/.gtkrc",homeDir);
    if ((fp = fopen(buf,"w")) == NULL) return -1;
    fputs("# -- THEME AUTO-WRITTEN DO NOT EDIT\n",fp);
    g_snprintf(buf,1024,"include \"%s/%s/gtk/gtkrc\"\n\n",themeDir,selectedTheme);
    fputs(buf,fp);
    g_snprintf(buf,1024,"include \"%s/.gtkrc.mine\"\n\n",homeDir);
    fputs(buf,fp);
    fputs("# -- THEME AUTO-WRITTEN DO NOT EDIT\n",fp);
    fclose(fp);
    return 0;
}

static void notifyAll(void)
{
    XEvent ev;
    Window rroot,rparent,*rchildren;
    unsigned int rn;
    int rformat;
    unsigned long rnitem, rafter;
    unsigned char *rdata;
    int i;
    Atom rtype = None;
    static Atom xa_wm_state = None, xa_wm_name = None;

    if (xa_wm_state == None) {
	xa_wm_state = XInternAtom(GDK_DISPLAY(),"WM_STATE",False);
	xa_wm_name = XInternAtom(GDK_DISPLAY(),"WM_NAME",False);
    }
    ev.xclient.type = ClientMessage;
    ev.xclient.display = GDK_DISPLAY();
    ev.xclient.format = 8;
    ev.xclient.message_type = XInternAtom(GDK_DISPLAY(),"_GTK_READ_RCFILES",False);
    if (XQueryTree(GDK_DISPLAY(),GDK_ROOT_WINDOW(),&rroot,&rparent,
         &rchildren,&rn)) {
	for (i = 0;i < rn;i++) {
	    XGetWindowProperty(GDK_DISPLAY(),rchildren[i],xa_wm_state,0,0,
	      False,AnyPropertyType,&rtype,&rformat,&rnitem,&rafter,&rdata);
	    if (rtype) {
		ev.xclient.window = rchildren[i];
		XSendEvent(GDK_DISPLAY(),rchildren[i],False,
		   NoEventMask,&ev);
	    } else {
		XGetWindowProperty(GDK_DISPLAY(),rchildren[i],xa_wm_name,0,0,
		  False,AnyPropertyType,&rtype,&rformat,&rnitem,&rafter,&rdata);
		if (rtype) {
		    ev.xclient.window = rchildren[i];
		    XSendEvent(GDK_DISPLAY(),rchildren[i],False,
		       NoEventMask,&ev);
		}
	    }
	}
	XFree(rchildren);
    }
    gdk_flush();
}

static void refresh(void)
{
    Window win;
    XSetWindowAttributes attr;
    unsigned long mask;

    mask = CWOverrideRedirect;
    attr.override_redirect = True;
    win = XCreateWindow(GDK_DISPLAY(),GDK_ROOT_WINDOW(),
              0,0,G_MAXSHORT,G_MAXSHORT,0,CopyFromParent,
	      InputOutput,CopyFromParent,
	                mask,&attr);
    XMapRaised(GDK_DISPLAY(),win);
    gdk_flush();
    XDestroyWindow(GDK_DISPLAY(),win);
    gdk_flush();
}

void
on_changeButton_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
    if (selectedTheme != NULL) {
	if (changeGtkrc() < 0) {
	    fprintf(stderr,"Can't change .gtkrc\n");
	    exit(2);
	}
	notifyAll();
	sleep(2);
	refresh();
    }
}

void
on_exitButton_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
    exit(0);
}

