/* 
   $Id: main.c,v 1.2 2001/12/25 10:38:47 sho Exp $

   Copyright (C) 2001,2002 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of sgswtheme.

   sgswtheme is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   sgswtheme is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with sgwm; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

/*
 * Gladeκmain.cեǤ. ԽɬפǤ.
 * GladeϤΥե񤭤ޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <dirent.h>

#include <gtk/gtk.h>

#include "interface.h"
#include "support.h"

static GtkCList *themeList;
GtkWidget *mainWindow;
char *themeDir = DATA_DIR "/themes";
char *selectedTheme = NULL;

static void usage(char *cmd)
{
    fprintf(stderr,"Usage:%s -d <theme directory>\n",cmd);
    exit(2);
}

static void parseOpt(int argc, char **argv)
{
    int i;

    for (i = 1;i < argc;i++) {
	if (argv[i][0] == '-') {
	    switch (argv[i][1]) {
	    case 'd':
		if (++i >= argc) {
		    usage(argv[0]);
		}
		themeDir = argv[i];
		break;
	    default:
		usage(argv[0]);
		break;
	    }
	} else {
	    usage(argv[0]);
	}
    }
}

static void makeThemeList(void)
{
    DIR *dp;
    struct dirent *de;
    char buf[NAME_MAX+1];
    char *p = buf;

    if ((dp = opendir(themeDir)) == NULL) {
	fprintf(stderr,"Can't open theme directory:%s\n",themeDir);
	exit(2);
    }
    while ((de = readdir(dp)) != NULL) {
	int n = de->d_reclen;

	if (n > NAME_MAX) n = NAME_MAX;
	bcopy(de->d_name,buf,n);
	buf[n] = '\0';
	if (strcmp(p,".") != 0 && strcmp(p,"..") != 0) {
	    gtk_clist_append(themeList,&p);
	}
    }
    closedir(dp);
}

static void themeSelected(GtkCList *clist, gint row, gint column,
  GdkEventButton *event, gpointer data)
{
    gtk_clist_get_text(clist,row,column,&selectedTheme);
}

int
main (int argc, char *argv[])
{
    GtkWidget *widget;

#ifdef ENABLE_NLS
  bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
  textdomain (PACKAGE);
#endif

  gtk_set_locale ();
  gtk_init (&argc, &argv);
  parseOpt(argc,argv);

  add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
  add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  mainWindow = create_mainWindow ();
  widget = lookup_widget(mainWindow, "themeList");
  themeList = GTK_CLIST(widget);
  makeThemeList();
  gtk_signal_connect((GtkObject *)widget,"select-row",themeSelected,NULL);
  gtk_widget_show (mainWindow);

  gtk_main ();
  return 0;
}

